
import javax.media.j3d.*;
import java.util.*;

public class CollisionBehavior extends Behavior {
  //
  private TransformGroup charactor;
  private WakeupCondition collisionCriterion;
  //---------------------------------------
  //
  public CollisionBehavior(TransformGroup charactor) {
    this.charactor=charactor;
  }
  //---------------------------------
  //
  public void initialize() {
    collisionCriterion=new WakeupOnCollisionEntry(charactor);
    wakeupOn(collisionCriterion);
  }
  //-------------------------------------
  //
  public void processStimulus(Enumeration criteria) {
    //
    WakeupCriterion criterion;
    WakeupOnCollisionEntry collision;
    //
    while(criteria.hasMoreElements()){
      criterion=(WakeupCriterion)(criteria.nextElement());
      //
      if(criterion instanceof WakeupOnCollisionEntry){
        collision=(WakeupOnCollisionEntry)(criterion);
        processCollision(collision);
      }
    }
    wakeupOn(collisionCriterion);
  }
  //---------------------------------------------
  //
  private void processCollision(WakeupOnCollisionEntry collision){
    Node ancestor;
    BranchGroup group;
    //
    if(collision.getTriggeringPath().getObject() instanceof Crystal2){
      for(int i=collision.getTriggeringPath().nodeCount()-1;i>=0;i--){
        ancestor=collision.getTriggeringPath().getNode(i);
        if(ancestor instanceof BranchGroup){
          group=(BranchGroup)(ancestor);
          if(group.getCapability(BranchGroup.ALLOW_DETACH)){
            group.detach();
          }
        }
      }
    }
  }
}
