import java.util.Enumeration;
import javax.media.j3d.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import javax.vecmath.*;

public class KeyEventBehavior extends Behavior {
  //
  private TransformGroup target;
  private TransformGroup cube;
  private WakeupCondition keyEventCriterion;
  //
  public KeyEventBehavior(TransformGroup target,TransformGroup cube) {
    this.target=target;
    this.cube=cube;
  }
  //-----------------------------
  //
  public void initialize() {
    //
    WakeupCriterion[] events;
    //
    events=new WakeupCriterion[2];
    events[0]=new WakeupOnAWTEvent(KeyEvent.KEY_PRESSED);
    events[1]=new WakeupOnAWTEvent(KeyEvent.KEY_RELEASED);
    //
    keyEventCriterion=new WakeupOr(events);
    wakeupOn(keyEventCriterion);
  }
  //---------------------------------
  //
  public void processStimulus(Enumeration criteria) {
    //
    WakeupCriterion criterion;
    AWTEvent[] events;
    //
    while(criteria.hasMoreElements()){
      criterion=(WakeupCriterion)(criteria.nextElement());
      //
      if(criterion instanceof WakeupOnAWTEvent){
        events=((WakeupOnAWTEvent)(criterion)).getAWTEvent();
        //
        for (int i=0;i<events.length;i++) {
          if (events[i] instanceof KeyEvent) {
            processKeyEvent((KeyEvent)(events[i]));
          }
        }
      }
    }
    //
    wakeupOn(keyEventCriterion);
  }
  //---------------------------------------------
  //
  private void processKeyEvent(KeyEvent event){
    //
    Transform3D move=new Transform3D();
    Transform3D now=new Transform3D();
    //Matrix4d matrix = new Matrix4d();
    //
    if(event.getID()==KeyEvent.KEY_PRESSED){
      /*switch(event.getKeyCode()){
        case KeyEvent.VK_UP:
          break;
        case KeyEvent.VK_DOWN:
          break;
      }*/
    }else if(event.getID()==KeyEvent.KEY_RELEASED){
      switch(event.getKeyCode()){
        case KeyEvent.VK_UP:
          move.set(new Vector3d(0.0,0.0,-0.15));
          target.getTransform(now);
          now.mul(move);
          target.setTransform(now);
          break;
        case KeyEvent.VK_DOWN:
          move.set(new Vector3d(0.0,0.0,0.15));
          target.getTransform(now);
          now.mul(move);
          target.setTransform(now);
          break;
        case KeyEvent.VK_RIGHT:
          move.rotY(-5*Math.PI/180);
          target.getTransform(now);
          //now.get(matrix);
          //now.setTranslation(new Vector3d(0.0,0.0,0.0));
          now.mul(move);
          //now.setTranslation(new Vector3d(matrix.m03,matrix.m13,matrix.m23));
          target.setTransform(now);
          break;
        case KeyEvent.VK_LEFT:
          move.rotY(5*Math.PI/180);
          target.getTransform(now);
          //now.get(matrix);
          //now.setTranslation(new Vector3d(0.0,0.0,0.0));
          now.mul(move);
          //now.setTranslation(new Vector3d(matrix.m03,matrix.m13,matrix.m23));
          target.setTransform(now);
          break;
        case KeyEvent.VK_NUMPAD8:
          move.set(new Vector3d(0.0,0.0,-0.15));
          cube.getTransform(now);
          now.mul(move);
          cube.setTransform(now);
          break;
        case KeyEvent.VK_NUMPAD6:
          move.set(new Vector3d(0.15,0.0,0.0));
          cube.getTransform(now);
          now.mul(move);
          cube.setTransform(now);
          break;
        case KeyEvent.VK_NUMPAD4:
          move.set(new Vector3d(-0.15,0.0,0.0));
          cube.getTransform(now);
          now.mul(move);
          cube.setTransform(now);
          break;
        case KeyEvent.VK_NUMPAD2:
          move.set(new Vector3d(0.0,0.0,0.15));
          cube.getTransform(now);
          now.mul(move);
          cube.setTransform(now);
          break;
        case KeyEvent.VK_NUMPAD3:
          move.rotY(-5*Math.PI/180);
          cube.getTransform(now);
          //now.get(matrix);
          //now.setTranslation(new Vector3d(0.0,0.0,0.0));
          now.mul(move);
          //now.setTranslation(new Vector3d(matrix.m03,matrix.m13,matrix.m23));
          cube.setTransform(now);
          break;
        case KeyEvent.VK_NUMPAD1:
          move.rotY(5*Math.PI/180);
          cube.getTransform(now);
          //now.get(matrix);
          //now.setTranslation(new Vector3d(0.0,0.0,0.0));
          now.mul(move);
          //now.setTranslation(new Vector3d(matrix.m03,matrix.m13,matrix.m23));
          cube.setTransform(now);
          break;
      }
    }
  }
}
