import java.applet.Applet;
import java.awt.Font;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Random;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.image.TextureLoader;
//-----------------------------------------
//zuIuWFNg쐬邽߂̃NX
class StageCarpenter {
  //u
  private static Random random=new Random();
  //ĂяõAvbg
  private Applet applet;
  //----------------------------------
  //RXgN^
  public StageCarpenter(Applet applet){
    this.applet=applet;
  }
  //=======================================
  //uInterpolatorTestvŎgp
  //
  public Node createBox(){
    //
    Material material;
    material=new Material();
    material.setAmbientColor(new Color3f(0.135f,0.2225f,0.11575f));
    material.setEmissiveColor(new Color3f(0.0f,0.0f,0.0f));
    material.setDiffuseColor(new Color3f(0.54f,0.89f,0.63f));
    material.setSpecularColor(new Color3f(0.316f,0.316f,0.316f));
    material.setShininess(12.8f);
    //
    TexCoordGeneration texCoordGeneration;
    texCoordGeneration=new TexCoordGeneration(TexCoordGeneration.SPHERE_MAP,TexCoordGeneration.TEXTURE_COORDINATE_2);
    //
    TextureAttributes textureAttributes;
    textureAttributes=new TextureAttributes();
    textureAttributes.setTextureMode(TextureAttributes.DECAL);
    //
    Appearance appearance;
    appearance=new Appearance();
    appearance.setMaterial(material);
    appearance.setTransparencyAttributes(new TransparencyAttributes(TransparencyAttributes.BLENDED,0.2f));
    appearance.setTexCoordGeneration(texCoordGeneration);
    appearance.setTexture(LoadTexture("back.jpg"));
    appearance.setTextureAttributes(textureAttributes);
    //
    TransformGroup translation;
    translation=new TransformGroup();
    translation.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    translation.addChild(new Box(0.5f,0.5f,0.5f,Box.GENERATE_TEXTURE_COORDS | Box.GENERATE_NORMALS,appearance));
    //
    Alpha alpha;
    alpha=new Alpha(-1,
                    Alpha.INCREASING_ENABLE | Alpha.DECREASING_ENABLE,
                    0,
                    100,
                    1000,
                    500,
                    100,
                    10000,
                    5000,
                    100);
    //
    Transform3D axis;
    axis=new Transform3D();
    axis.rotZ(-Math.PI*60/180);
    //
    PositionInterpolator interpolator;
    interpolator=new PositionInterpolator(alpha,translation,axis,-3.0f,3.0f);
    interpolator.setSchedulingBounds(new BoundingSphere(new Point3d(0.0,5.0,0.0),30.0));
    //
    TransformGroup transform;
    transform=new TransformGroup();
    transform.addChild(translation);
    transform.addChild(interpolator);
    //
    return transform;
  }
  //
  public Node createLight(){
    BranchGroup group;
    Light light;
    BoundingSphere bounds;
    //
    group=new BranchGroup();
    bounds=new BoundingSphere(new Point3d(),Double.POSITIVE_INFINITY);
    //
    light=new AmbientLight(new Color3f(0.5f,0.5f,0.5f));
    light.setInfluencingBounds(bounds);
    group.addChild(light);
    //
    light=new DirectionalLight(new Color3f(0.5f,0.5f,0.5f),new Vector3f(1.0f,-1.0f,-1.0f));
    light.setInfluencingBounds(bounds);
    group.addChild(light);
    //
    //bounds=new BoundingSphere(new Point3d(),5.0);
    //
    light=new PointLight(new Color3f(0.5f,0.5f,0.5f),new Point3f(0.0f,0.0f,1.0f),new Point3f(0.8f,0.0f,0.0f));
    light.setInfluencingBounds(bounds);
    group.addChild(light);
    //
    return group;
  }
  //=======================================
  //uCollisionDetachTestvŎgp
  //St{[
  public Node createBall(){
    //
    Appearance appearance;
    appearance=new Appearance();
    appearance.setTexture(LoadTexture("ball.jpg"));
    //
    Sphere sphere;
    sphere=new Sphere(0.2f,Sphere.GENERATE_TEXTURE_COORDS,appearance);
    //
    TransformGroup transform;
    transform=new TransformGroup();
    transform.addChild(sphere);
    //
    return transform;
  }
  //
  public Node createCrystals(){
    BranchGroup crystals=new BranchGroup();
    crystals.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    //
    BranchGroup subGroup;
    TransformGroup transform;
    Transform3D translation;
    for(int i=0;i<25;i++){
      translation=new Transform3D();
      translation.setTranslation(new Vector3d(
          random.nextDouble()*10.0-5.0,
          random.nextDouble()*1.0-0.5,
          random.nextDouble()*10.0-5.0));
      transform=new TransformGroup(translation);
      transform.addChild(new Crystal2());
      //
      subGroup=new BranchGroup();
      subGroup.setCapability(BranchGroup.ALLOW_DETACH);
      subGroup.setCapability(BranchGroup.ENABLE_COLLISION_REPORTING);
      subGroup.addChild(transform);
      //
      crystals.addChild(subGroup);
    }
    //
    return crystals;
  }
  //=======================================
  //uPrimitiveTestvŎgp
  //St{[
  public Node createSphere(){
    //
    Appearance appearance;
    appearance=new Appearance();
    appearance.setTexture(LoadTexture("ball.jpg"));
    //
    Sphere sphere;
    sphere=new Sphere(0.2f,Sphere.GENERATE_TEXTURE_COORDS,appearance);
    //
    Transform3D translation;
    translation=new Transform3D();
    translation.setTranslation(new Vector3d(-0.3,-0.2,0.7));
    //
    TransformGroup transform;
    transform=new TransformGroup(translation);
    transform.addChild(sphere);
    //
    return transform;
  }
  //J[R[
  public Node createCone(){
    TransformGroup transform,transformBox,transformCone;
    Transform3D translation,rotationBox,translationBox,multiBox,translationCone;
    Appearance appearanceBox,appearanceCone;
    Box box;
    Cone cone;
    //
    appearanceBox=new Appearance();
    appearanceBox.setTexture(LoadTexture("alert2.jpg"));
    //
    rotationBox=new Transform3D();
    rotationBox.rotY(Math.PI*30/180);
    //
    translationBox=new Transform3D();
    translationBox.setTranslation(new Vector3d(0.0,-0.4,0.0));
    //
    multiBox=new Transform3D();
    multiBox.mul(translationBox,rotationBox);
    transformBox=new TransformGroup(multiBox);
    //
    box=new Box(0.22f,0.05f,0.22f,Box.GENERATE_TEXTURE_COORDS,appearanceBox);
    transformBox.addChild(box);
    //
   appearanceCone=new Appearance();
   appearanceCone.setTexture(LoadTexture("alert.jpg"));
   //
    translationCone=new Transform3D();
    translationCone.setTranslation(new Vector3d(0.0,-0.1,0.0));
    transformCone=new TransformGroup(translationCone);
    //
    cone=new Cone(0.2f,0.6f,Cone.GENERATE_TEXTURE_COORDS,appearanceCone);
    transformCone.addChild(cone);
    //
    translation=new Transform3D();
    translation.setTranslation(new Vector3d(0.4,0.0,0.3));
    transform=new TransformGroup(translation);
    //
    transform.addChild(transformBox);
    transform.addChild(transformCone);
    //
    return transform;
  }
  //؂̖_
  public Node createCylinder(){
    TransformGroup transform;
    Transform3D multi,rotationY,rotationZ;
    Appearance appearance;
    Cylinder cylinder;
    //
    rotationY=new Transform3D();
    rotationY.rotY(Math.PI*110.0/180.0);
    //
    rotationZ=new Transform3D();
    rotationZ.rotZ(Math.PI*60.0/180.0);
    //
    multi=new Transform3D();
    multi.mul(rotationY,rotationZ);
    //
    transform=new TransformGroup(multi);
    //
    appearance=new Appearance();
    appearance.setTexture(LoadTexture("mokume.jpg"));
    //
    cylinder=new Cylinder(0.1f,1.2f,Cylinder.GENERATE_TEXTURE_COORDS,appearance);
    transform.addChild(cylinder);
    //
    return transform;
  }
  //Ő
  public Node createTile(){
    TransformGroup transform;
    Transform3D translation;
    Appearance appearance;
    Box tile;
    //
    translation=new Transform3D();
    translation.setTranslation(new Vector3d(0.0,-0.4,0.0));
    transform=new TransformGroup(translation);
    //
    appearance=new Appearance();
    appearance.setTexture(LoadTexture("sibahu.jpg"));
    //
    tile=new Box(0.8f,0.01f,1.0f,Box.GENERATE_TEXTURE_COORDS,appearance);
    transform.addChild(tile);
    //
    return transform;
  }
  //==============================================
  //uShape3DTestvŎgp
  //
  public Node createFloor(){//
    TransformGroup transform;
    Transform3D translation;
    Appearance appearance;
    GeometryArray geometry;
    //
    translation=new Transform3D();
    translation.setTranslation(new Vector3d(0.0,-0.4,0.0));
    transform=new TransformGroup(translation);
    //
    appearance=new Appearance();
    appearance.setTexture(LoadTexture("tatami.jpg"));
    //
    geometry=new QuadArray(4,QuadArray.COORDINATES | QuadArray.TEXTURE_COORDINATE_2);
    //
    geometry.setCoordinate(0,new Point3f(-5.0f,0.0f,5.0f));
    geometry.setCoordinate(1,new Point3f(5.0f,0.0f,5.0f));
    geometry.setCoordinate(2,new Point3f(5.0f,0.0f,-5.0f));
    geometry.setCoordinate(3,new Point3f(-5.0f,0.0f,-5.0f));
    //
    geometry.setTextureCoordinate(0,0,new TexCoord2f(0.0f,0.0f));
    geometry.setTextureCoordinate(0,1,new TexCoord2f(20.0f,0.0f));
    geometry.setTextureCoordinate(0,2,new TexCoord2f(20.0f,10.0f));
    geometry.setTextureCoordinate(0,3,new TexCoord2f(0.0f,10.0f));
    //
    transform.addChild(new Shape3D(geometry,appearance));
    //
    return transform;
  }
  //A
  public Node createWood(){
    SharedGroup share01,share02;
    Appearance appearance;
    GeometryArray geometry;
    //
    geometry=new QuadArray(4,QuadArray.COORDINATES | QuadArray.TEXTURE_COORDINATE_2);
    //
    geometry.setCoordinate(0,new Point3f(-0.2f,1.0f,0.0f));
    geometry.setCoordinate(1,new Point3f(-0.2f,0.0f,0.0f));
    geometry.setCoordinate(2,new Point3f(0.2f,0.0f,0.0f));
    geometry.setCoordinate(3,new Point3f(0.2f,1.0f,0.0f));
    //
    geometry.setTextureCoordinate(0,0,new TexCoord2f(0.0f,1.0f));
    geometry.setTextureCoordinate(0,1,new TexCoord2f(0.0f,0.0f));
    geometry.setTextureCoordinate(0,2,new TexCoord2f(1.0f,0.0f));
    geometry.setTextureCoordinate(0,3,new TexCoord2f(1.0f,1.0f));
    //
    appearance=new Appearance();
    appearance.setTexture(LoadTexture("hatiue01.gif"));
    appearance.setTransparencyAttributes(new TransparencyAttributes(TransparencyAttributes.BLENDED,0.0f));
    //
    share01=new SharedGroup();
    share01.addChild(new OrientedShape3D(geometry,appearance,OrientedShape3D.ROTATE_ABOUT_AXIS,new Vector3f(0.0f,1.0f,0.0f)));
    //
    appearance=new Appearance();
    appearance.setTexture(LoadTexture("hatiue02.gif"));
    appearance.setTransparencyAttributes(new TransparencyAttributes(TransparencyAttributes.BLENDED,0.0f));
    //
    share02=new SharedGroup();
    share02.addChild(new OrientedShape3D(geometry,appearance,OrientedShape3D.ROTATE_ABOUT_AXIS,new Vector3f(0.0f,1.0f,0.0f)));
    //
    BranchGroup group;
    TransformGroup transform,transformText;
    Transform3D translation,translationText,rotationText,multiText;
    Text2D text;
    String charactor[]={
      "","","","","","","","","","","","","","","","","","","","","","","","","",
      "","","","","","","","","","","","","","","","","","","",""
      };
    //
    group=new BranchGroup();
    for(double x=-4.5;x<4.5;x+=1.0){
      for(int z=-1;z<=1;z+=2){
        //
        text=new Text2D(charactor[Math.abs(random.nextInt()%45)],new Color3f(1.0f,1.0f,1.0f),"Monospaced",24,Font.BOLD);
        translationText=new Transform3D();
        translationText.setTranslation(new Vector3d(-0.05,1.0,0.0));
        rotationText=new Transform3D();
        rotationText.rotY((z+1)*Math.PI*90/180);
        multiText=new Transform3D();
        multiText.mul(rotationText,translationText);
        transformText=new TransformGroup(multiText);
        transformText.addChild(text);
        //
        translation=new Transform3D();
        translation.setTranslation(new Vector3d(x,-0.4,z*4.5));
        transform=new TransformGroup(translation);
        transform.addChild(new Link(share01));
        transform.addChild(transformText);
        group.addChild(transform);
        //
        text=new Text2D(charactor[Math.abs(random.nextInt()%45)],new Color3f(1.0f,1.0f,1.0f),"Monospaced",24,Font.BOLD);
        translationText=new Transform3D();
        translationText.setTranslation(new Vector3d(-0.05,1.0,0.0));
        rotationText=new Transform3D();
        rotationText.rotY((z+1)*Math.PI*90/180);
        multiText=new Transform3D();
        multiText.mul(rotationText,translationText);
        transformText=new TransformGroup(multiText);
        transformText.addChild(text);
        //
        translation=new Transform3D();
        translation.setTranslation(new Vector3d(x+0.5,-0.4,z*4.5));
        transform=new TransformGroup(translation);
        transform.addChild(new Link(share02));
        transform.addChild(transformText);
        group.addChild(transform);
      }
    }
    for(double z=-4.5;z<4.5;z+=1.0){
      for(int x=-1;x<=1;x+=2){
        //
        text=new Text2D(charactor[Math.abs(random.nextInt()%45)],new Color3f(1.0f,1.0f,1.0f),"Monospaced",24,Font.BOLD);
        translationText=new Transform3D();
        translationText.setTranslation(new Vector3d(-0.05,1.0,0.0));
        rotationText=new Transform3D();
        rotationText.rotY(-x*Math.PI*90/180);
        multiText=new Transform3D();
        multiText.mul(rotationText,translationText);
        transformText=new TransformGroup(multiText);
        transformText.addChild(text);
        //
        translation=new Transform3D();
        translation.setTranslation(new Vector3d(x*4.5,-0.4,z));
        transform=new TransformGroup(translation);
        transform.addChild(new Link(share01));
        transform.addChild(transformText);
        group.addChild(transform);
        //
        text=new Text2D(charactor[Math.abs(random.nextInt()%45)],new Color3f(1.0f,1.0f,1.0f),"Monospaced",24,Font.BOLD);
        translationText=new Transform3D();
        translationText.setTranslation(new Vector3d(-0.05,1.0,0.0));
        rotationText=new Transform3D();
        rotationText.rotY(-x*Math.PI*90/180);
        multiText=new Transform3D();
        multiText.mul(rotationText,translationText);
        transformText=new TransformGroup(multiText);
        transformText.addChild(text);
        //
        translation=new Transform3D();
        translation.setTranslation(new Vector3d(x*4.5,-0.4,z+0.5));
        transform=new TransformGroup(translation);
        transform.addChild(new Link(share02));
        transform.addChild(transformText);
        group.addChild(transform);
      }
    }
    //
    return group;
  }
  //
  public Node createCrystal(){
    //
    SharedGroup crystal;
    crystal=new SharedGroup();
    crystal.addChild(new Crystal());
    //
    BranchGroup group;
    TransformGroup transform;
    Transform3D translation;
    //
    group=new BranchGroup();
    for(int i=0;i<200;i++){
      //
      double x,y,z;
      do{
        x=150*random.nextDouble();
        if(random.nextBoolean()){x*=-1;}
        y=150*random.nextDouble();
        if(random.nextBoolean()){y*=-1;}
        z=150*random.nextDouble();
        if(random.nextBoolean()){z*=-1;}
      }while(Math.abs(x)<10 && Math.abs(z)<10);
      //
     translation=new Transform3D();
     translation.setTranslation(new Vector3d(x,y,z));
     transform=new TransformGroup(translation);
     transform.addChild(new Link(crystal));
     group.addChild(transform);
    }
    //
    return group;
  }
  //
  public Node createFog(BranchGroup group){
    Fog fog;
    Bounds bounds;
    //
    bounds=new BoundingSphere(new Point3d(),Double.POSITIVE_INFINITY);
    fog=new ExponentialFog(new Color3f(0.8f,0.9f,1.0f),0.1f);
    fog.setInfluencingBounds(bounds);
    fog.addScope(group);
    //
    return fog;
  }
  //======================================================
  //
  //-------------------------------------------------------
  //eNX`[摜̎擾
  private Texture LoadTexture(String filename){
    return LoadTexture(filename,0);
  }
  private Texture LoadTexture(String filename,int flags){
    Texture texture;
    URL location;
    //
    try{
      location=new URL(applet.getDocumentBase(),filename);
      texture=new TextureLoader(location,flags,applet).getTexture();
    }catch(MalformedURLException e){
      e.printStackTrace();
      texture=null;
    }
    //
    return texture;
  }
  //---------------------------------------------------
  //wi
  public Node createHeaven(){
    HeavenlyBody heaven;
    Appearance appearance;
    //
    appearance=new Appearance();
    appearance.setTexture(LoadTexture("back.jpg",TextureLoader.Y_UP));
    heaven=new HeavenlyBody(30,appearance);
    //
    return heaven;
  }
}